           title read volumes
_vr41      segment
           assume cs:_vr41,ds:_vr41 
           org 100h
       ;
       ; dated 7-19-88
       ;
       ; game directory read from external file games
       ;      can contain up to 20 games to expand
       ;      change value in read in subroutine getgames
       ;      and expand length of gamedir
       ;
       ; changed .txt file open so that file is not created 
       ;      if game files can not be found
       ;
       ; displays current directory for file realted messages
       ;
       ; decodes and writes objects also
       ; 
       ; dated 6-3-88
       ;
       ; program reads vol files from sierra online games
       ; then decodes them so text is readable 
       ; 
       ; to run sierra game directories must be in a 
       ; logical fashion                
       ;      c:\sierra\kq1               
       ;      c:\sierra\kq2                  
       ;      c:\sierra\sq1                  
       ;
       ; input parm is                                            
       ;                                                
       ;    vr41 c:\sierra                                    
       ;                                                              
       ; note include drive id but not ending backslash
       ;
       ;     t (default) for text processing
       ;     v           for info in records imbeeded in vols
       ; 
       ; program output is found in kq1.txt for text
       ;                         or kq1.vol for record only info
       ; 
       ;  cm1 is sierra xmas card
       ;           
start:     jmp dir
       ;
       ; main driver section
       ;
dir:       call    getgames          ; get the game file
           call    getparm           ; get the parm from the command line
           call    startup           ; set txt ind get drive
           lea     bp,gamedir        ; point bp to game directory
           call    fstgame           ; process first game
           xor     ax,ax    
volloop:   mov     al,volbin         ; set up vol bin  
           call    nextvol           ; get the next volume number
           cmp     openfail,1h       ; if open fail eq 1 then new game
           jne     provol            ; else process volume
           call    openobj           ; open object file
           call    decobj            ; decode object file
           call    writobj           ; write out objects 
           call    newgame           ; process new game
           lea     bp,doneflag       ; point to done flag    
           cmp byte ptr [bp],01h     ; if 1 we are done  
           jne     volloop           ; else process vol
           call    retdos            ; return to dos
           lea     bp,outname        ; determine ouput name
           add     bp,3              ; point past directory
provol:    call    process           ; process the volume
           call    closeit           ; close volume 
           jmp     volloop           ; loop through volume          
getparm:   xor     si,si             ; point si to parm area in psp
           add     si,080h
           lea     di,highdir
           xor     ax,ax             ; load string byte
           lodsb
           cmp     al,0h             ; if length is zero then default
           jne     haveparm
           call    default
           jmp     parmret      
haveparm:  mov     cx,ax             ; set cx for looping
prmloop:   xor     ax,ax             ; load the first byte of parm area
           lodsb       
           cmp     al,020h           ; is it a blank
           jne     testval           ; if so get the next
           jmp     nxtparm
 testval:  cmp     al,regslash       ; next char is text or vol no dir
           jne     calldir
           cmp     founddir,01h       ;  if founddir set then no defaul
           je      calltv 
           call    nodrive
           mov     founddir,01h
calltv:    call    testtv            ; test for vol or text ind
           jmp     parmret
calldir:   call    testdir
           mov     founddir,01h
           cmp     cl,0h
           je      parmret 
nxtparm:   loop    prmloop 
parmret:   ret               
testtv:    xor     ax,ax  
           lodsb 
           cmp     al,056h           ; if v set txtind to 0  
           je      setforvol
           cmp     al,076h           ; if cap v set for vol
           je      setforvol         
           cmp     al,054h           ; if t set txtind to 1  
           je      settxt 
           cmp     al,074h           ; if cap t set for txt
           je      settxt        
settxt:    xor     ax,ax             ; set txtind to 1
           inc     ax
           lea     di,txtind
           stosw
           jmp     setret
setforvol: xor     ax,ax             ; set txtind to 0
           lea     di,txtind
           stosw
setret:    ret
testdir:   stosb
           lodsb
           cmp     al,20h             ; is it blank  
           je      dmdone
           loop    testdir
dmdone:    mov     al,backslash                                       
           stosb
           mov     al,00h
           stosb
           dec     di 
           mov     enddir,di                            
           ret                          
default:   xor     ax,ax             ; set txtind to 1
           inc     ax
           lea     di,txtind
           stosw
nodrive:   xor     ax,ax             ; determine current drive
           mov     ah,19h 
           int     21h
           add     al,41h            ; a drive = 0 but letter a = 41h
           lea     di,highdir
           stosb
           xor     ax,ax
           mov     al,03ah           ; store colon
           stosb
           mov     al,00h
           stosb                     ; end indicator 
           ret
         ;
         ; read the games file for game list
         ;
getgames:  xor     ax,ax              ; open the game file
           mov     ah,3dh
           lea     dx,gamedsn        ; open file 
           int     21h
           jnb     readgame          ; file is open 
           mov     bx,00h            ; list input file
           lea     cx,m211           ; end of message
           lea     dx,gamerr         ; point dx to error message
           call    scrnmsg           ; write to screen
           call    retdos
readgame:  mov     bx,ax             ; set up the handle
           mov     ah,3fh
           mov     cx,050h           ; read it all
           lea     dx,gamedir        ; read file 
           int     21h
           jnb     closegame         ; done with file 
           mov     bx,00h            ; list input file
           lea     cx,m211           ; end of message
           lea     dx,gamerr         ; point dx to error message
           call    scrnmsg           ; write to screen
           call    retdos
closegame: xor     ax,ax
           mov     ah,3eh
           int     21h
           jnb     gameret           ; done with file 
           mov     bx,00h            ; list input file
           lea     cx,m211           ; end of message
           lea     dx,gamerr         ; point dx to error message
           call    scrnmsg           ; write to screen
           call    retdos
gameret:   ret
         ;
         ; determine current drive
         ; first time routine
         ;
startup:   cmp     txtind,1          ; text ind eq 1 process test
           je      movtxt
           lea     si,vq             ; point source to vol qualifier
           jmp     qual              ; process qualifier
movtxt:    lea     si,tq             ; point source to txt qualifier       
qual:      lea     di,outname        ; out file name
           add     di,4              ; bump to qualifier position
           cld
           mov     cx,3              ; move three bytes
           repnz   movsb             ; move it 
           ret                       ; return to driver
         ;
         ; read the next vol for this game
         ; if not found end of game
         ;
nextvol:   add     al,30h            ; change to binary 0
           lea     bp,filename       ; point bp to start of file name
           mov     [bp+4],al         ; store current volume in file name
           mov     hdrcnt,0h         ; reset header record counter 
           cld
           lea     di,byteread       ; zero out byte read
           xor     ax,ax
           stosw
           stosw                     ; twice as byte read is double word    
           mov     openfail,0h       ; reset open fail flag
           xor     ax,ax
           mov     ah,3dh
           lea     dx,filename       ; open file 
           int     21h
           jnb     inhand            ; file is open 
           mov     bx,01h            ; list input file
           lea     cx,m011           ; end of message
           lea     dx,openerr        ; point dx to error message
           call    filemsg           ; go display message
           mov     bx,01h
           lea     cx,m011
           lea     dx,openerr
           call    scrnmsg           ; write to screen
           mov     openfail,1h       ; set flag to 1
inhand:    mov     handle,ax         ; save file handle 
           ret                        ; return to driver
         ;
         ; main process
         ;
process:   mov     bx,01h            ; list input file
           lea     cx,m091           ; end of message
           lea     dx,procfile       ; point dx to error message
           call    filemsg           ; go display message
           mov     bx,01h
           lea     cx,m091
           lea     dx,procfile       ; display process file message
           call    scrnmsg           ; go display message   
nexthdr:   inc     hdrcnt,1          ; increment record count
           cld
           lea     si,byteread       ; bytes read
           lea     di,hdrstr         ; header start
           mov     cx,04h            ; move 4 bytes  
movbyhi:   movsb 
           loop    movbyhi 
           mov     cx,05h            ; most headers are 5
           mov     hdrlen,cx         ; save it at cx
           mov     ax,cx             ; save at ax    
           xor     dx,dx             ; xor dx      
           add     ax,word ptr byteread[2]
           adc     dx,word ptr byteread[0]
           lea     di,byteread
           add     di,02h            ; point di to lower half of byteread
           stosw
           mov     ax,dx             ; now store upper half
           lea     di,byteread
           stosw             
           xor     ax,ax 
           mov     bx,handle         ; bx needs handle   
           mov     ah,3fh            ; read file
           mov     cx,5h             ; read five byte header
           lea     dx,rechdr         ; point dx to 5 byte header
           int     21h 
testhdr:   jnb     prochdr           ; read bytes now process
           cmp     ax,0h             ; eof
           jne     error1            ; must be error
           jmp     retdriv           ; retrun to driver
error1:    mov     bx,01h            ; list input file
           lea     cx,m021           ; end of message
           lea     dx,hdrerr         ; point dx to error message
           call    scrnmsg           ; go display message
           call    retdos            ; return to dos
prochdr:   cmp     ax,0h             ; eof
           jne     nexttest          ; must be error    
           jmp     retdriv           ; return to driver
nexttest:  cmp     ax,cx             ; should be equal
           je      byte1             ; ok test first byte
           mov     bx,01h            ; list input file
           lea     cx,m041           ; end of message
           lea     dx,lenerr         ; point dx to error message
           call    scrnmsg           ; go display message
           call    retdos            ; return to dos
byte1:     lea     bp,rechdr         ; point bp to 5 byte header
           cmp byte ptr [bp],12h     ; first  byte should be 12
           je      byte2             ; ok test second byte
           mov     bx,01h            ; list input file
           lea     cx,m051           ; end of message
           lea     dx,fberr          ; point dx to error message
           call    scrnmsg           ; go display message
           call    retdos            ; return to dos
byte2:     cmp byte ptr [bp+1],34h   ; second byte should be 34
           je      byte3             ; ok test third byte
           cmp byte ptr [bp+1],12h   ; this is except 3
           jne      sberrtyp 
           call    exc3              ; exception 3
           jmp     byte1     
sberrtyp:  mov     bx,01h            ; list input file
           lea     cx,m061           ; end of message
           lea     dx,sberr          ; point dx to error message
           call    scrnmsg           ; go display message
           call    retdos            ; return to dos 
byte3:     xor     cx,cx             ; zero cx before loading volume
           mov     cl,volbin         ; move volume to cl 
           cmp     cl,[bp+2]         ; third byte should be volume 
           je      prolen            ; ok so process length
           cmp byte ptr [bp+2],12h   ; is this exception 4
           jne     volerrtyp         ; volume error
           call    exc4              ; process exception
           jmp     byte1             ; retest header
volerrtyp: mov     bx,01h            ; list input file
           lea     cx,m071           ; end of message
           lea     dx,volerr         ; point dx to error message
           call    scrnmsg           ; go display message
           call    retdos            ; return to dos
prolen:    xor     ax,ax             ; move detail record length to cx
           lea     si,rechdr         ; point si to rechdr
           add     si,3h             ; bump si to detail length
           lodsw
           cmp     ax,3412h          ; check for first exception 
           jne     noexc1            ; header is ok 
           mov     bx,0h             ; do not list  file
           lea     cx,m121           ; end of message
           lea     dx,exc1mess       ; point dx to error message
           call    filemsg           ; go display message
           call    exc1              ; handle exception 1
           jmp     testhdr           ; retest header    
noexc1:    mov     savelen,ax        ; now move length to savelen
           cmp     ah,12h            ; except 2 new header starts in last byte
           je      callexc2          ; get ready to call chkexc2
           xor     bx,bx             ; bx = 0 means ok
           jmp     setread           ; go read detail  
callexc2:  call    chkexc2           ; check if first 4 of detail is header
           cmp     bx,0h             ; if bx = 0 then new header go test it
           jne     setread           ; not 0 so go read
           jmp     byte1    
setread:   mov     cx,savelen        ; put length in cx    
           xor     ax,ax
           lea     dx,recdtl         ; point dx to buffer
           cmp     bx,0h             ; if bx is 0 read detail as always
           je      readrest          ; read rest of detail  
           sub     cx,bx             ; have  read first bx already
           add     dx,bx             ; point dx past first bx   
readrest:  mov     adjlen,bx         ; save length adjustment in bx
           mov     bx,handle         ; load file handle
           mov     ah,3fh
           int     21h               ; read record
           jnb     detrec
           mov     bx,01h            ; list input  file
           lea     cx,m031           ; end of message
           lea     dx,dtlerr         ; point dx to error message
           call    scrnmsg           ; go display message
           call    retdos            ; return to dos
detrec:    mov     bx,adjlen         ; restore adjusted length
           add     cx,bx             ; adjust printed length
           mov     hexfield,cx       ; convert record length
           mov     holdlen,cx
           lea     di,decdl
           call    decode          
           mov     cx,hdrcnt         ; do header count
           mov     hexfield,cx       ; do header count
           lea     di,deccnt
           call    decode
           cmp     hdrlen,05h        ; standard header
           je      seths5 
           mov     bx,hdrlen         ; bump start by amount over 5 
           sub     bx,05h
           add     word ptr hdrstr[2],bx
           sub     hdrlen,bx 
seths5:    lea     si,hdrstr
           lodsw  
           mov     hexfield,ax       ;
           lea     di,dechs
           call    decode
           lea     si,hdrstr
           add     si,02h            ; now do last half        
           lodsw  
           mov     hexfield,ax       ;
           lea     di,dechs
           add     di,04h
           call    decode
           mov     cx,hdrlen         ; conver header length
           mov     hexfield,cx
           lea     di,dechl
           call    decode
           mov     ax,hdrlen         ; save at ax    
           xor     dx,dx             ; xor dx      
           add     ax,word ptr hdrstr[2]
           adc     dx,word ptr hdrstr[0]
           lea     di,dtlstr
           add     di,02h            ; point di to lower half of hdrstr
           stosw
           mov     ax,dx             ; now store upper half
           lea     di,dtlstr
           stosw
           lea     si,dtlstr
           lodsw  
           mov     hexfield,ax       ;
           lea     di,decds
           call    decode
           lea     si,dtlstr
           add     si,02h            ; now do last half        
           lodsw  
           mov     hexfield,ax       ;
           lea     di,decds
           add     di,04h
           call    decode
           mov     ax,holdlen        ; save at ax    
           xor     dx,dx             ; xor dx      
           add     ax,word ptr byteread[2]
           adc     dx,word ptr byteread[0]
           lea     di,byteread
           add     di,02h            ; point di to lower half of hdrstr
           stosw
           mov     ax,dx             ; now store upper half
           lea     di,byteread
           stosw
           call    dirfind           ; find dir location     
           mov     bx,0h             ; list output  file
           lea     cx,m161           ; end of message
           lea     dx,dtlgood        ; point dx to error message
           call    filemsg           ; go display message
           cmp     txtind,0          ; process text
           je      jmphdr
           call    dectxt            ; decode text
jmphdr:    jmp     nexthdr 
retdriv:   ret                       ; retrun to driver
         ; 
         ; search the dir fot this header
         ;
dirfind:   cld
           lea     si,hdrstr         ; adjust header start for vol no
           lodsw
           xor     ah,ah             ; high byte is always 0
           xor     bx,bx
           mov     bl,volbin
           shl     bl,1
           shl     bl,1
           shl     bl,1
           shl     bl,1              ; vol number is in high nibble of bl
           add     al,bl             ; al is now high byte of 3 byte key
           lea     di,searchkey
           stosb
           xor     ax,ax 
           lodsb                     ; load the second byte
           xor     bx,bx             ; save second byte in bx
           mov     bx,ax
           xor     ax,ax
           lodsb                     ; load byte 3 save in byte 2 of search
           stosb
           xor     ax,ax
           mov     ax,bx             ; move in byte 2
           stosb                     ; searchkey  header start plus vol
           cld    
           xor     cx,cx
           lea     di,logbuf         ; find it in the log
nextlog:   lea     si,searchkey
           cmpsb
           jne     lbump2
           cmpsb    
           jne     lbump1
           cmpsb
           jne     ltestend 
           mov     hexfield,cx      ; decode the directory entry number
           mov     dircount,cx
           lea     di,decdc
           call    decode
           cld
           lea     si,logind        ; found it in the logdir  
           lea     di,dtldir
           mov     cx,3
           repnz   movsb
           jmp     srchret
lbump2:    add     di,2
           jmp     ltestend 
lbump1:    add     di,1
ltestend:  add     cx,1             ; increment entry number
           cmp     di,logend        ; past end of log file 
           jge     testpic
           jmp     nextlog          ; test next log entry         
testpic:   cld    
           xor     cx,cx
           lea     di,picbuf         ; find it in the pic 
nextpic:   lea     si,searchkey
           cmpsb
           jne     pbump2
           cmpsb    
           jne     pbump1
           cmpsb
           jne     ptestend 
           mov     hexfield,cx      ; decode the directory entry number
           mov     dircount,cx
           lea     di,decdc
           call    decode
           cld
           lea     si,picind        ; found it in the picdir  
           lea     di,dtldir
           mov     cx,3
           repnz   movsb
           jmp     srchret
pbump2:    add     di,2
           jmp     ptestend 
pbump1:    add     di,1
ptestend:  add     cx,1             ; increment entry number
           cmp     di,picend        ; past end of pic  file 
           jge     testvue
           jmp     nextpic          ; test next pic entry         
testvue:   cld    
           xor     cx,cx
           lea     di,vuebuf         ; find it in the viewdir 
nextvue:   lea     si,searchkey
           cmpsb
           jne     vbump2
           cmpsb    
           jne     vbump1
           cmpsb
           jne     vtestend 
           mov     hexfield,cx      ; decode the directory entry number
           mov     dircount,cx
           lea     di,decdc
           call    decode
           cld
           lea     si,vueind        ; found it in the vuedir  
           lea     di,dtldir
           mov     cx,3
           repnz   movsb
           jmp     srchret
vbump2:    add     di,2
           jmp     vtestend 
vbump1:    add     di,1
vtestend:  add     cx,1             ; increment entry number
           cmp     di,vueend        ; past end of vue  file 
           jge     testsnd
           jmp     nextvue          ; test next vue entry         
testsnd:   cld    
           xor     cx,cx
           lea     di,sndbuf         ; find it in the snddir 
nextsnd:   lea     si,searchkey
           cmpsb
           jne     sbump2
           cmpsb    
           jne     sbump1
           cmpsb
           jne     stestend 
           mov     hexfield,cx      ; decode the directory entry number
           mov     dircount,cx
           lea     di,decdc
           call    decode
           cld
           lea     si,sndind        ; found it in the snddir  
           lea     di,dtldir
           mov     cx,3
           repnz   movsb
           jmp     srchret
sbump2:    add     di,2
           jmp     stestend 
sbump1:    add     di,1
stestend:  add     cx,1             ; increment entry number
           cmp     di,sndend        ; past end of snd  file 
           jge     notfound
           jmp     nextsnd          ; test next snd entry         
notfound:  lea     si,nfind         ; could not find dir
           lea     di,dtldir
           mov     cx,3
           repnz   movsb 
           xor     cx,cx            ; set entry number to 0
           mov     dircount,cx
           mov     hexfield,cx
           lea     di,decdc
           call    decode
srchret:   ret
         ;
         ; file close routine
         ;              
closeit:   mov     bx,handle         ; load file handle
           xor     ax,ax
           mov     ah,3eh
           int     21h               ; close file  
           jnb     endvol            ; file is closed
           mov     bx,01h            ; list input  file
           lea     cx,m001           ; end of message
           lea     dx,closerr        ; point dx to error message
           call    scrnmsg           ; go display message
           call    retdos            ; return to dos
endvol:    mov     bx,01h            ; list input  file
           lea     cx,m111           ; end of message
           lea     dx,endfile        ; point dx to error message
           call    filemsg           ; go display message
           mov     bx,01h            ; list input  file
           lea     cx,m111           ; end of message
           lea     dx,endfile        ; point dx to error message
           call    scrnmsg           ; go display message
           xor     ax,ax
           mov     al,volbin         ; move volbin to al
           add     al,1h             ; increment al by 1
           mov     volbin,al         ; store binary volume number
           ret                       ; retrun to driver  
        ;
        ; exception 1
        ;
exc1:      mov     ax,3412h          ; cx has 1234 first 2 bytes of rechdr
           lea     di,rechdr         ; point di to rechdr
           stosw
           xor     ax,ax
           mov     ax,03h            ; save at ax    
           xor     dx,dx             ; xor dx      
           add     ax,word ptr byteread[2]
           adc     dx,word ptr byteread[0]
           lea     di,byteread
           add     di,02h            ; point di to lower half of byteread
           stosw
           mov     ax,dx             ; now store upper half
           lea     di,byteread
           stosw             
           mov     dx,hdrlen         ; load header lengthg          
           add     dx,03h            ; 3 bytes
           mov     hdrlen,dx         ; save header length
           xor     ax,ax
           mov     bx,handle
           lea     dx,rechdr         ; point dx to header
           add     dx,2h             ; point dx past 1234
           mov     cx,3h             ; read 3 bytes
           mov     ah,3fh             
           int     21h
           ret
         ;
         ; exception 2
         ;
chkexc2:   mov     recdtl,12h        ; blast 12 inot first byte
           xor     ax,ax
           mov     bx,handle
           mov     cx,4              ; read first four bytes of detail
           lea     dx,recdtl         ; point to detail buffer
           add     dx,1              ; bump past 12h in first byte 
           mov     ah,3fh
           int     21h
           jnb     testexc2
           mov     bx,01h            ; list input  file
           lea     cx,m101           ; end of message
           lea     dx,badexc2        ; point dx to error message
           call    scrnmsg           ; go display message
           call    retdos            ; return to dos 
testexc2:  lea     bp,recdtl         ; point bp to header
           cmp byte ptr [bp],12h     ; is it 12
           jne     noexc2            ; it is not - ok as is
           cmp byte ptr [bp+1],34h   ; is it 34
           jne     noexc2            ; no - detail is ok
           mov     cl,volbin         ; load vol into cx
           cmp     cl,[bp+2]         ; compare to input
           jne     noexc2            ; close but ok
           cld                       ; clear direct flag need to increment
           mov     cx,5h             ; will move 5 bytes
           lea     si,recdtl         ; from the detail area
           lea     di,rechdr         ; to the header area
dtltohdr:  movsb                     ; move the byte
           loop    dtltohdr          ; loop back for next
           mov     ax,04h            ; save at ax    
           xor     dx,dx             ; xor dx      
           add     ax,word ptr byteread[2]
           adc     dx,word ptr byteread[0]
           lea     di,byteread
           add     di,02h            ; point di to lower half of byteread
           stosw
           mov     ax,dx             ; now store upper half
           lea     di,byteread
           stosw 
           mov     bx,0h             ; do not list   file
           lea     cx,m131           ; end of message
           lea     dx,exc2mess       ; point dx to error message
           call    filemsg           ; go display message
           xor     bx,bx             ; tell caller to read detail
           mov     dx,hdrlen         ; load header lengthg          
           add     dx,04h            ; 4  bytes
           mov     hdrlen,dx         ; save header length
           jmp     endofe2           ; return to caller
noexc2:    mov     cx,04h            ; move 4 bytes back 1 byte
           lea     si,recdtl
           inc     si                ; now we point to first byte to move
           lea     di,recdtl         ; destination is recdtl
mov4byte:  movsb
           loop    mov4byte          ; do it 4 times           
           mov     bx,4h             ; tell caller have read 4 bytes of dtl   
endofe2:   ret
         ;
         ; exception 3
         ;
exc3:      lea     si,rechdr         ; point si to recdtl plus 1  
           add     si,1h
           lea     di,rechdr         ; point di to recdtl
           mov     cx,4h             ; loop four times  
           cld
nextexc3:  movsb
           loop    nextexc3
           mov     ax,01h            ; save at ax    
           xor     dx,dx             ; xor dx      
           add     ax,word ptr byteread[2]
           adc     dx,word ptr byteread[0]
           lea     di,byteread
           add     di,02h            ; point di to lower half of byteread
           stosw
           mov     ax,dx             ; now store upper half
           lea     di,byteread
           stosw 
           mov     dx,hdrlen         ; load header length          
           add     dx,01h            ; 1   bytes
           mov     hdrlen,dx         ; save header length
           xor     ax,ax 
           mov     bx,handle
           mov     cx,1              ; read last byte of new header
           lea     dx,rechdr         ; point dx to buffer plus 4
           add     dx,4h
           mov     ah,3fh            ; read the byte
           int     21h
           mov     bx,0h             ; do not list   file
           lea     cx,m141           ; end of message
           lea     dx,exc3mess       ; point dx to error message
           call    filemsg           ; go display message
           ret
        ;
        ; exception 4
        ;         	
exc4:      lea     si,rechdr         ; point si to recdtl plus 2  
           add     si,2h
           lea     di,rechdr         ; point di to recdtl
           mov     cx,3h             ; loop three  times  
           cld
nextexc4:  movsb
           loop    nextexc4
           mov     ax,02h            ; save at ax    
           xor     dx,dx             ; xor dx      
           add     ax,word ptr byteread[2]
           adc     dx,word ptr byteread[0]
           lea     di,byteread
           add     di,02h            ; point di to lower half of byteread
           stosw
           mov     ax,dx             ; now store upper half
           lea     di,byteread
           stosw             
           mov     dx,hdrlen         ; load header lengthg          
           add     dx,02h            ; 2   bytes
           mov     hdrlen,dx         ; save header length
           xor     ax,ax 
           mov     bx,handle
           mov     cx,2              ; read last 2 byte of new header
           lea     dx,rechdr         ; point dx to buffer plus 3
           add     dx,3h
           mov     ah,3fh            ; read the byte
           int     21h
           mov     bx,0h             ; do not list   file
           lea     cx,m151           ; end of message
           lea     dx,exc4mess       ; point dx to error message
           call    filemsg           ; go display message
           ret
        ;
        ; change a hex field to display 
        ;         
decode:    add     di,3h            ; this is last byte
           std                      ;  will decrease di
           mov     cx,4h            ; do it four times
nextdig:   mov     ax,hexfield      ; move hex num to ax     
           mov     bx,ax            ; move hex num to bx
           shr     bx,1             ; shift the right most 4 bits
           shr     bx,1
           shr     bx,1
           shr     bx,1
           mov     hexfield,bx      ; save this for nest iteration
           shl     bx,1             ; right digit is now zero
           shl     bx,1
           shl     bx,1
           shl     bx,1
           sub     ax,bx            ; low order digit in ax
           cmp     al,9h            ; convert to display
           jg      atof             ; must be a to f
           add     al,30h           ; this is 0 to 9 add 30h
           jmp     stodig           ; store that digit
atof:      add     al,37h           ; this is a to f add 37h
stodig:    stosb                    ; store at decfield
           loop    nextdig          ; do it again
           ret
         ;
         ; new game routine
         ;            
newgame:   mov     bx,outhand       ; out file handle    
           mov     volbin,0h        ; reset volume number to 0 
           xor     ax,ax
           mov     ah,3eh
           int     21h
           jnb     endout           ; ouput file is closed
           mov     bx,02h           ; list output  file
           lea     cx,m001          ; end of message
           lea     dx,closerr       ; point dx to error message
           call    scrnmsg          ; go display message
           call    retdos           ; return to dos
endout:    mov     bp,gamepos       ; point bp to front of game  list
           add     bp,4h            ; bump to nest game
fstgame:   mov     gamepos,bp       ; save new position - entry for first
           cmp byte ptr [bp],78h    ; is it x then done
           jne     setname
           jmp     doneret          ; newret  
setname:   cld                      ; increment di si
           mov     si,bp            ; source for game name
           mov     di,enddir        ; dest is input 
           mov     cx,3             ; moving 3 byte name
           repnz   movsb
           xor     ax,ax
           stosb
           cld
           mov     si,bp            ; source for game name
           lea     di,outname       ; output file name
           mov     cx,3             ; move 3 bytes
           repnz   movsb
         ;
         ; change directory
         ;
           xor    ax,ax
           mov    ah,3bh
           lea    dx,highdir
           add    dx,2             ; add 2 to bump past drive i
           int    21h
           jnb    openlog
           mov    di,enddir
           add    di,2              ; if change fails then backup
           cmp byte ptr [di],031h   ; make sure is is 1
           jne    msgderr 
           xor    ax,ax             ; make pq1 pq
           stosb
           mov    ah,3bh
           lea    dx,highdir
           int    21h
           jnb    openlog
msgderr:   mov    bx,03h 
           lea    cx,m221
           lea    dx,direrr
           call   scrnmsg
           jmp   endout  
         ;
         ; process log file
         ;
openlog:   cld
           xor     ax,ax
           xor     cx,cx
           lea     dx,logname
           mov     ah,3dh           ; open logdir  file
           int     21h
           jnb     readlog 
           mov     bx,03h           ; list logdir  file
           lea     cx,m011
           lea     dx,openerr
           call    scrnmsg 
           jmp     endout            ; process next game
readlog:   mov     bx,ax
           mov     dirhand,ax
           xor     ax,ax
           mov     cx,0ffffh         ; read file 
           lea     dx,logbuf         ; read into buffer 
           mov     ah,3fh            ; read the byte
           int     21h
           jnb     closelog 
           mov     bx,03h           ; list logdir  file
           lea     cx,m031
           lea     dx,dtlerr
           call    scrnmsg 
           call    retdos
closelog:  mov     loglen,ax        ; save file length
           lea     dx,logbuf        ; calculate ending address
           add     dx,ax
           mov     logend,dx  
           xor     ax,ax
           mov     bx,dirhand
           mov     ah,3eh           ; close the file
           int     21h
           jnb     openpic
           mov     bx,03h           ; list logdir  file
           lea     cx,m001
           lea     dx,closerr
           call    scrnmsg 
           call    retdos
         ;
         ; process pic file
         ;
openpic:   cld
           xor     ax,ax
           xor     cx,cx
           lea     dx,picname
           mov     ah,3dh           ; open picdir  file
           int     21h
           jnb     readpic 
           mov     bx,04h           ; list picdir  file
           lea     cx,m011
           lea     dx,openerr
           call    scrnmsg 
           call    retdos
readpic:   mov     bx,ax
           mov     dirhand,ax
           xor     ax,ax 
           mov     cx,0ffffh         ; read file 
           lea     dx,picbuf         ; read into buffer 
           mov     ah,3fh            ; read the byte
           int     21h
           jnb     closepic 
           mov     bx,04h           ; list picdir  file
           lea     cx,m031
           lea     dx,dtlerr
           call    scrnmsg 
           call    retdos
closepic:  mov     piclen,ax        ; save file length
           lea     dx,picbuf        ; calculate ending address
           add     dx,ax
           mov     picend,dx  
           xor     ax,ax
           mov     bx,dirhand
           mov     ah,3eh           ; close the file
           int     21h
           jnb     openvue
           mov     bx,04h 
           lea     cx,m001
           lea     dx,closerr
           call    scrnmsg 
           call    retdos
         ;
         ; process vue file
         ;
openvue:   cld
           xor     ax,ax
           xor     cx,cx
           lea     dx,vuename
           mov     ah,3dh           ; open vuedir  file
           int     21h
           jnb     readvue 
           mov     bx,05h           ; list vuedir  file
           lea     cx,m011
           lea     dx,openerr
           call    scrnmsg 
           call    retdos
readvue:   mov     bx,ax
           mov     dirhand,ax
           xor     ax,ax
           mov     cx,0ffffh         ; read file 
           lea     dx,vuebuf         ; read into buffer 
           mov     ah,3fh            ; read the byte
           int     21h
           jnb     closevue 
           mov     bx,05h           ; list vuedir  file
           lea     cx,m031
           lea     dx,dtlerr
           call    scrnmsg 
           call    retdos
closevue:  mov     vuelen,ax        ; save file length
           lea     dx,vuebuf        ; calculate ending address
           add     dx,ax
           mov     vueend,dx  
           xor     ax,ax
           mov     bx,dirhand
           mov     ah,3eh           ; close the file
           int     21h
           jnb     opensnd
           mov     bx,05h           ; list vuedir  file
           lea     cx,m001
           lea     dx,closerr
           call    scrnmsg 
           call    retdos
         ;
         ; process snd file
         ;
opensnd:   cld
           xor     ax,ax
           xor     cx,cx
           lea     dx,sndname
           mov     ah,3dh           ; open snddir  file
           int     21h
           jnb     readsnd 
           mov     bx,06h           ; list snddir  file
           lea     cx,m011
           lea     dx,openerr
           call    scrnmsg 
           call    retdos
readsnd:   mov     bx,ax
           mov     dirhand,ax
           xor     ax,ax
           mov     cx,0ffffh         ; read file 
           lea     dx,sndbuf         ; read into buffer 
           mov     ah,3fh            ; read the byte
           int     21h
           jnb     closesnd 
           mov     bx,06h           ; list snddir  file
           lea     cx,m031
           lea     dx,dtlerr
           call    scrnmsg 
           call    retdos
closesnd:  mov     sndlen,ax        ; save file length
           lea     dx,sndbuf        ; calculate ending address
           add     dx,ax
           mov     sndend,dx  
           xor     ax,ax
           mov     bx,dirhand
           mov     ah,3eh           ; close the file
           int     21h
           jnb     newret
           mov     bx,06h           ; list snddir  file
           lea     cx,m001
           lea     dx,closerr
           call    scrnmsg 
           call    retdos
newret:    xor     ax,ax
           xor     cx,cx
           lea     dx,outname
           mov     ah,3ch           ; open new out file
           int     21h
           jnb     goodout
           mov     bx,02h           ; list output file
           lea     cx,m011
           lea     dx,openerr
           call    scrnmsg 
           call    retdos
goodout:   mov     outhand,ax       ; save output handle
           ret
doneret:   inc     doneflag         ; come here after all game processed
           ret
         ;
         ; process object file
         ;
openobj:   cld
           xor     ax,ax
           xor     cx,cx
           lea     dx,objname
           mov     ah,3dh           ; open object  file
           int     21h
           jnb     readobj 
           mov     bx,07h           ; list object  file
           lea     cx,m011
           lea     dx,openerr
           call    scrnmsg 
           call    retdos
readobj:   mov     bx,ax
           mov     dirhand,ax
           xor     ax,ax
           mov     cx,0ffffh         ; read file 
           lea     dx,objbuf         ; read into buffer 
           mov     ah,3fh            ; read the byte
           int     21h
           jnb     closeobj 
           mov     bx,07h           ; list object  file
           lea     cx,m031
           lea     dx,dtlerr
           call    scrnmsg 
           call    retdos
closeobj:  mov     objlen,ax        ; save file length
           lea     dx,objbuf        ; calculate ending address
           add     dx,ax
           mov     objend,dx  
           xor     ax,ax
           mov     bx,dirhand
           mov     ah,3eh           ; close the file
           int     21h
           jnb     objret
           mov     bx,07h           ; list object  file
           lea     cx,m001
           lea     dx,closerr
           call    scrnmsg 
           call    retdos
objret:    ret           
        ;
        ; decode text
        ;
dectxt:    lea     bx,recdtl        ; bx to record detail
           lea     si,rechdr
           add     si,3             ; point si to detail length
           lodsw                    ; ax contains length
           add     bx,ax            ; bx is last byte of detail
           mov     recend,bx        ; save end of detail for compare
           lea     si,recdtl        ; point si to byte 1 and 2 of dtl
           lodsw
           lea     bp,recdtl
           add     bp,2             ; point to third byte of dtl
           add     bp,ax            ; bp points to address of offset
           mov     xset,bp          ; save offset for text decoding 
           add     bp,1             ; bump 1 to compare end
           mov     si,bp            ; source is offset to end
           lodsw
           add     bp,ax            ; bp should point to last byte      
           cmp     bx,bp            ; if equal see if it is log   
           jne     testlog          ; if not equal is it log no text
           cmp byte ptr dtldir,06ch ; see if it is little l
           je      xsetbx           ; bx bp equal and log so go on
           mov     bx,0h             ; text in non log record
           lea     cx,m201          
           lea     dx,notlogtxt
           call    filemsg
           jmp     xsetbx
testlog:   cmp byte ptr dtldir,06ch ; see if it is little l
           je      ntlr
           jmp     decret           ; bx bp not equal and not log so return
ntlr:      mov     bx,0h             ; no text in  log record
           lea     cx,m191         
           lea     dx,logexcp 
           call    filemsg
           jmp     decret 
xsetbx:    mov     bx,xset          ; offset to bx
           mov     si,bx            ; point source for decoding
           xor     ax,ax            ; zero ax
           lodsb                    ; ax contains offset to start of text
           add     ax,1             ; bump by one
           shl     ax,1             ; multiply by 2
           add     bx,ax            ; bx points to first byte of text
           inc     bx
           mov     di,bx            ; di to first byte of text
           mov     txtfb,bx         ; stsrt of text
           cld                      ; increment si after load 
mravis:    lea     si,avis          ; the magical mr durgan  
           xor     cx,cx
           mov     cl,0bh           ; avis is 11 long
nxtdec:    lodsb
           xor     [di],al          ; xor
           inc     di               ; only si incremented by lod  
           loop    nxtdec 
           mov     dx,di  
           cmp     dx,recend        ; end of record 
           jge     writetxt         ; write text t
           jmp     mravis           ; decode next byte        
writetxt:  lea     dx,txtmsg         ; text  message  
           lea     cx,m181           
           mov     bx,0h
           call    filemsg
           mov     dx,txtfb          ; first byte of text
           mov     si,txtfb          ; move address of first byte
           inc     si                ; point to byte 2
nxtbyt:    xor     ax,ax
           mov     di,si             ; if byte eq 1a then change to 20
           lodsb
           cmp     al,01ah           ; end of file marker
           jne     no1a
           mov     al,020h           ; make it  blank
           stosb
no1a:      cmp     al,00h            ; end of line indicator
           je      writslin
           cmp     si,recend
           jge     writslin  
           jmp     nxtbyt  
writslin:  mov     cx,si             ; end of text
           mov     bx,0h
           call    filemsg
           cmp     si,recend         ; end of record
           jg      tempret
           mov     dx,si  
           jmp     nxtbyt
tempret:   ret          
decret:    ret
        ;
        ; decode object
        ;
decobj:    lea     di,objbuf        ; di to first byte of object
           cld                      ; increment si after load 
objavis:   lea     si,avis          ; the magical mr durgan  
           xor     cx,cx
           mov     cl,0bh           ; avis is 11 long
nxtobj:    lodsb
           xor     [di],al          ; xor
           inc     di               ; only si incremented by lod  
           loop    nxtobj 
           mov     dx,di  
           cmp     dx,objend        ; end of object 
           jge     decobjret        ; return       
           jmp     objavis         ; decode next byte        
decobjret: ret
        ;  
        ; write objects to file
        ;
writobj:  mov     bx,0h              ; do not write file
          lea     cx,m231            ; write object follows message
          lea     dx,objfoll
          call    filemsg
          lea     si,objbuf          ; point si to start of object buffer
          add     si,6               ; start of offset table 
          xor     ax,ax
          lodsb                      ; load offset to first object
          lea     dx,objbuf          ; dx points to buffer
          add     dx,ax
          add     dx,3               ; dx points to first object
nxtobjtw: xor     cx,cx
          mov     cx,dx
tobj00:   mov     bp,cx              ; seems like cx doesnt work as [cx]
          cmp byte ptr [bp],00h      ; if 00 then done with this object
          je      wronam  
          inc     cx                 ; write a byte
          cmp     cx,objend
          jg      wrtoret     
          jmp     tobj00
wronam:   mov     bx,00h
          push    cx                 ; save cx as filemsg modifies cx               
          call    filemsg
          pop     cx
          mov     dx,cx              ;  point dx to next obj
          inc     dx
          cmp     dx,objend          ;  is it end 
          jl      nxtobjtw 
wrtoret:  ret                
        ;
        ; write to file 
        ;         
filemsg:   mov     fileyn,bx         ; save file end   
           sub     cx,dx             ; calc bytes to print
           mov     bx,outhand              
           xor     ax,ax
           mov     ah,040h
           int     21h
           jnb     prntfile
           mov     bx,02h            ; write output file name
           lea     cx,m171           ; end of message
           lea     dx,writerr
           call    scrnmsg
           call    retdos            ; return to dos
prntfile:  mov     bx,fileyn         ; test for file
           cmp     bx,00h            ; if 0 return 
           je      listcclf
           call    geterrdir         ; get directory fo rerror line
           xor     ax,ax
           mov     ah,40h 
           mov     bx,outhand
           lea     dx,filearea      
           int     21h
           call    findfile
           sub     cx,dx             ; calc bytes to print
           mov     bx,outhand              
           xor     ax,ax
           mov     ah,040h
           int     21h
           jnb     listcclf 
           mov     bx,02h            ; write output file name
           lea     cx,m171           ; end of message
           lea     dx,writerr
           call    scrnmsg
           call    retdos
listcclf:  mov     cx,02h            ;  cc lf
           lea     dx,cclf           ; car cont line feed 
           mov     bx,outhand
           xor     ax,ax
           mov     ah,40h
           int     21h
           ret
        ;
        ; write to screen
        ;    
scrnmsg:   mov     fileyn,bx         ; save file end   
           xor     ax,ax
           mov     ah,9h
           int     21h
           mov     bx,fileyn         ; test for file
           cmp     bx,00h            ; if 0 return 
           je      scrncclf
           call    geterrdir         ; get directory and display 
           lea     dx,filearea
           xor     ax,ax
           mov     ah,09h
           int     21h
           call    findfile           ; which file for display  
sgofile:   xor     ax,ax
           mov     ah,9h
           int     21h
scrncclf:  xor     ax,ax
           lea     dx,cclf
           mov     ah,9h
           int     21h
scrnret:   ret
           ;
           ;  determine directory for display 
           ;
geterrdir: lea     si,highdir
           lea     di,filearea
highfile:  cmp byte ptr     [si],00h 
           je      mdirdone 
           movsb
           jmp     highfile
mdirdone:  movsb
           lea     bp,filearea       ; point bp to filearea 
           sub     cx,cx             ; cx will point to last byte
next00:    cmp byte ptr [bp],00h     ; if 00 then at end
           je      foundend
           inc     cx
           inc     bp
           jmp     next00 
foundend:  mov byte ptr [bp+1],024h   ; shove dollar sign 
           ret
           ;
           ;  determine file for display line
           ; 
findfile:  mov     bx,fileyn         ; set the file indicator  
           cmp     bx,01h            ; if 1 input
           je      ifile
           cmp     bx,03h            ; if 3 log
           je      lfile
           cmp     bx,04h            ; if 4 pic
           je      pfile
           cmp     bx,05h            ; if 5 vue
           je      vfile
           cmp     bx,06h            ; if 6 snd
           je      sfile
           cmp     bx,07h            ; if 7 object file
           je      ofile
           lea     dx,outname        ; point dx to output file name
           lea     cx,m911           ; end of file
           jmp     gofile
ifile:     lea     dx,filename       ; input file name
           lea     cx,m901    
           jmp     gofile
lfile:     lea     dx,logname        ; logdir   input file name
           lea     cx,m931    
           jmp     gofile
pfile:     lea     dx,picname        ; picdir   input file name
           lea     cx,m941    
           jmp     gofile
vfile:     lea     dx,vuename        ; vuedir   input file name
           lea     cx,m951    
           jmp     gofile
sfile:     lea     dx,sndname        ; snddir   input file name
           lea     cx,m961
ofile:     jmp     gofile
           lea     dx,objname
           lea     cx,m971
gofile:    ret
        ;
        ; return to dos
        ;
retdos:    xor     ax,ax             ; display ok message
           mov     bx,0h             ; no files
           lea     cx,m081 
           lea     dx,okmess         ;    
           call    scrnmsg  
           xor     ax,ax
           mov     ah,4ch            ; return to dos
           int     21h
           ret                       ; just in case 
hexfield   dw      0h
dirhand    dw      0h
recend     dw      0h
xset       dw      0h 
avis       db      'Avis Durgan'         
filename   db      'vol. '
m901       db      00h
           db      '$'
outname    db      '   .   '  
m911       db      00h
           db      '$' 
logname    db      'logdir'   
m931       db      00h
           db      '$'
picname    db      'picdir'  
m941       db      00h
           db      '$'
vuename    db      'viewdir'  
m951       db      00h
           db      '$'
sndname    db      'snddir'  
m961       db      00h
           db      '$'
objname    db      'object'
m971       db      00h
           db      '$'           
volname    db      'vol.0vol.1vol.2vol.3'
           db      00h
gamedsn    db      'games'
           db      00h
openfail   dw      00h
           db      'game name' 
thisgame   db      '   '
           db      'text ind'
txtind     dw      01h               ; 0 = vol only 1 = txt also
tq         db      'txt'
vq         db      'vol'  
searchkey  db      '   '             ; used to find dir entries
logind     db      'log'
picind     db      'pic'
vueind     db      'vue'
sndind     db      'snd'
nfind      db      '***'
highdir    db      '                                            '
           db      50 dup (20h)
founddir   db      00h
backslash  db      '\'
regslash   db      '/'
dircount   dw      00h               ; entry into dir from 0           
volbin     db      00h
enddir     dw      00h
currvol    db      00h
doneflag   db      00h               ; 0 if more games to process else 1 
hdrcnt     dw      00h
savelen    dw      0h
handle     dw      0h
outhand    dw      0h
gamepos    dw      0h
fileyn     dw      0h 
adjlen     dw      0h
txtfb      dw      00h
hdrstr     dd      00h
hdrlen     dw      00h
dtlstr     dd      00h
byteread   dd      00h
holdlen    dw      00h
loglen     dw      00h
piclen     dw      00h
vuelen     dw      00h
sndlen     dw      00h
objlen     dw      00h
logend     dw      00h
picend     dw      00h
vueend     dw      00h
sndend     dw      00h
objend     dw      00h  
cclf       db      0dh
           db      0ah
           db      00h 
           db      '$' 
rechdrc    db      'rec header here'
rechdr     db      '     '
           db      00h  
closerr    db      'can not close file  '
m001       db      '$'           
           db      00h
openerr    db      'can not open file  '
m011       db      '$'
           db      00h
hdrerr     db      'error reading file hdr '
m021       db      '$' 
           db      00h
dtlerr     db      'error reading detail record  '
m031       db      '$' 
           db      00h
lenerr     db      'header length not 5   '
m041       db      '$'
           db      00h
fberr      db      'first byte not 12  '
m051       db      '$' 
           db      00h
sberr      db      'second byte not 34  '
m061       db      '$'
           db      00h
volerr     db      'volume number not correct  '
m071       db      '$'
           db      00h       
okmess     db      'program ended normally  '
m081       db      '$'
           db      00h
procfile   db      'processing file  ' 
m091       db      '$'
           db      00h
badexc2    db      'error while testing for exception 2  '
m101       db      '$'
           db      00h
endfile    db      'end of file  '
m111       db      '$'
           db      00h
exc1mess   db      'exception 1 length is 1234h   '
m121       db      '$'
           db      00h
exc2mess   db      'exception 2 1234 starts in byte 5  '
m131       db      '$'
           db      00h
exc3mess   db      'exception 3 1234 starts in byte 2  '  
m141       db      '$'
           db      00h
exc4mess   db      'exception 4 1234 starts in byte 3  '  
m151       db      '$'
           db      00h
dtlgood    db      'read detail record number  '
           db      ' '
deccnt     db      '    '   
           db      ' '
dechs      db      '        '
           db      ' '
dechl      db      '    '
           db      ' '
decds      db      '        '
           db      ' ' 
decdl      db      '    '
           db      '  '
dtldir     db      '   '
           db      '  '
decdc      db      '    '
           db      ' '
m161       db      '$'
           db      00h
writerr    db      'write file error '
m171       db      '$'  
           db      00h
txtmsg     db      'text follows '
m181       db      '$'
           db      00h 
logexcp    db      'log record with no text '
m191       db      '$'
           db      00h 
notlogtxt  db      'not a log record but has text '
m201       db      '$'
           db      00h
gamerr     db      'error reading game file '
m211       db      '$'
           db      00h
direrr     db      'error changing directory'
m221       db      '$'
           db      00h 
objfoll    db      'objects follow   '
m231       db      '$'
           db      00h
filearea   db      ' :\                                   '
           db      '$'
           db      00h  
gamedir    db      100 dup (0h) 
           db      00h 
logbuf     db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      00h
picbuf     db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      00h
vuebuf     db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      00h
sndbuf     db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      00h
objbuf     db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      00h 
recdtl     db      256 dup (0h)
           db      256 dup (0h)       
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)  
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)       
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)  
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      256 dup (0h)
           db      00h                        
_vr41       ends
           end     start





            